unit ctype;
{
    C/C++ ctype.h
    (C) Copyright 1996  John Webster Small
    All rights reserved
}

interface

function isalnum(c : char) : boolean;
function isalpha(c : char) : boolean;
function iscntrl(c : char) : boolean;
function isdigit(c : char) : boolean;
function isgraph(c : char) : boolean;
function islower(c : char) : boolean;
function isprint(c : char) : boolean;
function ispunct(c : char) : boolean;
function isspace(c : char) : boolean;
function isupper(c : char) : boolean;
function isxdigit(c: char) : boolean;
function tolower(c : char) : char;
function toupper(c : char) : char;

implementation

function isalnum(c : char) : boolean;
  begin isalnum := isalpha(c) or isdigit(c); end;
function isalpha(c : char) : boolean;
  begin isalpha := isupper(c) or islower(c); end;
function iscntrl(c : char) : boolean;
  begin iscntrl := Byte(c) < Byte(#27); end;
function isdigit(c : char) : boolean;
  begin isdigit := c in [#0 .. #9]; end;
function isgraph(c : char) : boolean;
  begin isgraph := ((Byte(c) > 32)
    and (Byte(c) < 127)); end;
function islower(c : char) : boolean;
  begin islower := c in ['a'..'z']; end;
function isprint(c : char) : boolean;
  begin isprint := ((Byte(c) >= 32)
    and (Byte(c) < 127)); end;
function ispunct(c : char) : boolean;
  begin ispunct := (isprint(c)
    and (not isspace(c))
    and (not isalnum(c))); end;
function isspace(c : char) : boolean;
  begin isspace := c in [#9,#10,#11,#12,#13,#32]; end;
function isupper(c : char) : boolean;
  begin isupper := c in ['A'..'Z']; end;
function isxdigit(c: char) : boolean;
  begin isxdigit := (isdigit(c)
    or (c in ['A'..'F','a'..'f'])); end;
function tolower(c : char) : char;
  begin
    if c in ['A'..'Z'] then
       tolower := Char(Byte(c)-Byte('A')+Byte('a'))
    else
       tolower := c;
  end;
function toupper(c : char) : char;
  begin
    if c in ['a'..'z'] then
       toupper := Char(Byte(c)-Byte('a')+Byte('A'))
    else
       toupper := c;
  end;

begin
end.
